﻿Option Strict On
Imports System.Collections.ObjectModel
Imports System.Windows.Input
Imports DialogFensterTest2.ViewModel.Instrastructure
Imports DialogFensterTest2.ViewModel.Services

Public Class OrdnerBrowserViewModel
    Inherits Instrastructure.ViewModelBase

    Public Sub New()
        Verzeichnisse = New ObservableCollection(Of String)
        _Verzeichnisse = New ObservableCollection(Of String)
        Dim AlleLaufwerke() As System.IO.DriveInfo = System.IO.DriveInfo.GetDrives
        For Each item In AlleLaufwerke
            Verzeichnisse.Add(item.Name)
        Next
        _GewaehltesVerzeichnis = ""
    End Sub

    Private _Verzeichnisse As ObservableCollection(Of String)
    Public Property Verzeichnisse As ObservableCollection(Of String)
        Get
            Return _Verzeichnisse
        End Get
        Set(value As ObservableCollection(Of String))

            _Verzeichnisse = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _GewaehltesVerzeichnis As String
    Public Property GewaehltesVerzeichnis As String
        Get
            If String.IsNullOrEmpty(_GewaehltesVerzeichnis) Then
                Return ""
            Else
                Return _GewaehltesVerzeichnis
            End If
        End Get
        Set(value As String)
            _GewaehltesVerzeichnis = value
            'If _GewaehltesVerzeichnis <> Nothing Then
            'Dim AlleVerzeichnisse() = System.IO.Directory.GetDirectories(_GewaehltesVerzeichnis)
            'Verzeichnisse.Clear()
            'For Each item In AlleVerzeichnisse
            'Verzeichnisse.Add(item)
            'Next
            RaisePropertyChanged()
            'End If
            Debug.WriteLine("gesettet")
        End Set
    End Property

    Private _OrdnerZurueck As ICommand
    Public ReadOnly Property OrdnerZurueck() As ICommand
        Get
            If _OrdnerZurueck Is Nothing Then _OrdnerZurueck = New RelayCommand(AddressOf OrdnerZurueck_Execute, Function(o) True)
            Return _OrdnerZurueck
        End Get
    End Property
    Private Sub OrdnerZurueck_Execute(obj As Object)

        If _GewaehltesVerzeichnis.Length = 3 Then
            Verzeichnisse.Clear()
            Dim AlleLaufwerke() As System.IO.DriveInfo = System.IO.DriveInfo.GetDrives
            For Each item In AlleLaufwerke
                Verzeichnisse.Add(item.Name)
            Next
        ElseIf String.IsNullOrEmpty(_GewaehltesVerzeichnis) = False Then
            'Dim UebergeordnetesVerzeichnis As String = System.IO.Path.GetPathRoot(_GewaehltesVerzeichnis).ToString
            Dim info As New System.IO.DirectoryInfo(_GewaehltesVerzeichnis)
            Dim UebergeordnetesVerzeichnis As String = info.Parent.FullName
            GewaehltesVerzeichnis = UebergeordnetesVerzeichnis
            OeffneVerzeichnis_Execute(UebergeordnetesVerzeichnis)
        End If
    End Sub

    Private _OeffneVerzeichnis As ICommand
    Public ReadOnly Property OeffneVerzeichnis() As ICommand
        Get
            If _OeffneVerzeichnis Is Nothing Then _OeffneVerzeichnis = New RelayCommand(AddressOf OeffneVerzeichnis_Execute, Function(o) True)
            Return _OeffneVerzeichnis
        End Get
    End Property
    Private Sub OeffneVerzeichnis_Execute(obj As Object)
        Try
            Dim Objekt = DirectCast(obj, String)
            GewaehltesVerzeichnis = Objekt
            Dim AlleVerzeichnisse() = System.IO.Directory.GetDirectories(GewaehltesVerzeichnis)
            Verzeichnisse.Clear()
            For Each item In AlleVerzeichnisse
                Verzeichnisse.Add(item)
            Next
        Catch ex As Exception
            Dim dialogService = ServiceContainer.GetService(Of IDialogWindowService)
            Dim OKVM = New OKDialogViewModel
            OKVM.Meldung = "Verzeichnis konnte nicht geöffnet werden. Fehlermeldung:" & Environment.NewLine & ex.Message
            dialogService.ShowModalDialog("", OKVM, Me, True, False, WindowStyle.None, ResizeMode.NoResize, 500, SizeToContent.Height, WindowStartupLocation.CenterOwner, "")
        End Try
    End Sub

    Private _Ergebnis As String
    Public Property Ergebnis As String
        Get
            Return _Ergebnis
        End Get
        Set(value As String)
            _Ergebnis = value
            RaisePropertyChanged()
        End Set
    End Property


    Private _OK As ICommand
    Public ReadOnly Property OK() As ICommand
        Get
            If _OK Is Nothing Then _OK = New RelayCommand(AddressOf OK_Execute, Function(o) True)
            Return _OK
        End Get
    End Property
    Private Sub OK_Execute(obj As Object)
        Ergebnis = GewaehltesVerzeichnis
        Dim dialogService = ServiceContainer.GetService(Of IDialogWindowService)
        dialogService.CloseDialog(Me)
    End Sub

End Class
