﻿Namespace Services

    Public Interface IDialogWindowService
        Function ShowModalDialog(windowname As String, datacontext As Object, owner As Object, topMost As Boolean, showInTaskbar As Boolean, WindowStil As WindowStyle, Resize As ResizeMode, Width As Integer, AutoGroesse As SizeToContent, StartPosition As WindowStartupLocation, Titel As String) As Boolean
        Sub CloseDialog()
        Sub CloseDialog(vm As Object)
    End Interface

    Public Enum WindowStyle
        '
        ' Zusammenfassung:
        '     Nur der Clientbereich sichtbar ist-Titelleiste und Rahmen werden nicht angezeigt.
        '     Ein System.Windows.Navigation.NavigationWindow mit einer System.Windows.Window.WindowStyle
        '     von System.Windows.WindowStyle.None zeigt weiterhin die Navigation Benutzeroberfläche
        '     (User Interface, UI).
        None = 0
        '
        ' Zusammenfassung:
        '     Ein Fenster mit einem einzelnen Rahmen. Dies ist der Standardwert.
        SingleBorderWindow = 1
        '
        ' Zusammenfassung:
        '     Ein Fenster mit einem 3D Rahmen.
        ThreeDBorderWindow = 2
        '
        ' Zusammenfassung:
        '     Ein verankertes Toolfenster.
        ToolWindow = 3
    End Enum

    Public Enum ResizeMode
        '
        ' Zusammenfassung:
        '     Ein Fenster kann nicht geändert werden. Die Minimieren und Maximieren Schaltflächen
        '     werden nicht in der Titelleiste angezeigt.
        NoResize = 0
        '
        ' Zusammenfassung:
        '     Ein Fenster kann nur minimiert und wiederhergestellt werden. Die Minimieren und
        '     Maximieren Schaltflächen sind beide angezeigt, jedoch nur die Minimieren Schaltfläche
        '     ist aktiviert.
        CanMinimize = 1
        '
        ' Zusammenfassung:
        '     Die Größe eines Fensters kann geändert werden. Die Minimieren und Maximieren
        '     Schaltflächen angezeigt und aktiviert sind.
        CanResize = 2
        '
        ' Zusammenfassung:
        '     Die Größe eines Fensters kann geändert werden. Die Minimieren und Maximieren
        '     Schaltflächen angezeigt und aktiviert sind. Ein Ziehpunkt zum Ändern der Größe
        '     wird in der unteren rechten Ecke des Fensters angezeigt.
        CanResizeWithGrip = 3
    End Enum

    Public Enum SizeToContent
        '
        ' Zusammenfassung:
        '     Gibt an, dass ein Fenster nicht automatisch seine Größe an die Größe seines Inhalts
        '     anpasst. Stattdessen wird die Größe eines Fensters bestimmt, durch andere Eigenschaften,
        '     einschließlich System.Windows.FrameworkElement.Width, System.Windows.FrameworkElement.Height,
        '     System.Windows.FrameworkElement.MaxWidth, System.Windows.FrameworkElement.MaxHeight,
        '     System.Windows.FrameworkElement.MinWidth, und System.Windows.FrameworkElement.MinHeight.
        '     Finden Sie unter WPF Windows Overview.
        Manual = 0
        '
        ' Zusammenfassung:
        '     Gibt an, dass ein Fenster automatisch seine Breite auf die Breite des seinen
        '     Inhalt, aber nicht hoch.
        Width = 1
        '
        ' Zusammenfassung:
        '     Gibt an, dass ein Fenster automatisch seine Höhe der Höhe von deren Inhalt, jedoch
        '     nicht die Breite.
        Height = 2
        '
        ' Zusammenfassung:
        '     Gibt an, dass ein Fenster automatisch die Breite und Höhe auf die Breite und
        '     Höhe des Inhalts.
        WidthAndHeight = 3
    End Enum

    Public Enum WindowStartupLocation
        '
        ' Zusammenfassung:
        '     Die Startposition eines ein System.Windows.Window wird im Code festgelegt oder
        '     auf den Standardwert verzögert Windows Speicherort.
        Manual = 0
        '
        ' Zusammenfassung:
        '     Die Startposition eines eine System.Windows.Window wird von die Mitte des Bildschirms,
        '     der den Cursor enthält.
        CenterScreen = 1
        '
        ' Zusammenfassung:
        '     Die Startposition eines eine System.Windows.Window steht im Mittelpunkt einer
        '     der System.Windows.Window besitzt, gemäß der System.Windows.Window.Owner Eigenschaft.
        CenterOwner = 2
    End Enum
End Namespace